unit Main;

{ ToDo list
  143: -Message "Start creating new dir and copying". OK.
       -Not enough space-message before copying.      OK.
       -Disk full without message.                    OK.
       -Check A: and B: safe while changing drive.    OK.
  150: -User definable extensions                     OK.
       -Windows help file                             OK.
       -Sourcefile listbox itemIndex more convenient  OK.
  154: -Editable Title bar                            OK.
       -Only one program's instance                   OK.
       -Write only? Ask for removal                   OK.
       -On overwrite: show which file is newer        OK.
}

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, FileCtrl,
  ExtCtrls, Menus;

const
  ScreenWidth  : LongInt = 800; {I designed my form in 800x600 mode.}
  ScreenHeight : LongInt = 600;
  CopyBufferLength : Longint = 16384;
  WM_AUTOCOPY = WM_USER + 100;

  DefaultCaption1 = 'Binaries';  DefaultExt1 = 'exe,dcu,dsm,dsk';
  DefaultCaption2 = 'Backups';   DefaultExt2 = '~df,~dp,~pa';
  DefaultCaption3 = 'Pictures';  DefaultExt3 = 'bmp,cur,ico';
  DefaultCaption4 = 'UserDef';   DefaultExt4 = '';

type
  TMainForm = class(TForm)
    ButtonCopyFiles: TButton;
    Panel1: TPanel;
    cbExt2: TCheckBox;
    cbExt3: TCheckBox;
    cbExt1: TCheckBox;
    Label3: TLabel;
    ButtonHelp: TButton;
    ButtonMkDir: TButton;
    ButtonExit: TButton;
    PopupMenuMain: TPopupMenu;
    PopupItemShowHints: TMenuItem;
    ButtonAbour: TButton;
    PanelDestination: TPanel;
    Label2: TLabel;
    DestinationDrive: TDriveComboBox;
    DestinationPath: TLabel;
    DestinationDirectory: TDirectoryListBox;
    DestinationFiles: TFileListBox;
    Panel2: TPanel;
    Label1: TLabel;
    SourceDrive: TDriveComboBox;
    SourcePath: TLabel;
    SourceDirectory: TDirectoryListBox;
    SourceFiles: TFileListBox;
    FIleCount: TLabel;
    FilesLength: TLabel;
    RadioGroupOverwrite: TRadioGroup;
    Free: TLabel;
    PopupMenuSrcFiles: TPopupMenu;
    PopupItemDeleteSrcFile: TMenuItem;
    PopupItemRemovefromlist: TMenuItem;
    ButtonAutoCopy: TButton;
    PopupMenuDest: TPopupMenu;
    PopupItemLinktosourcedirectory: TMenuItem;
    GaugeCounter: TLabel;
    cbExt4: TCheckBox;
    PopupMenuExclude: TPopupMenu;
    SetDefaultExt: TMenuItem;
    MenuCustomize: TMenuItem;
    PopupMenuDestFiles: TPopupMenu;
    MenuDeleteDestFile: TMenuItem;
    procedure ButtonExitClick(Sender: TObject);
    procedure SourceDriveChange(Sender: TObject);
    procedure DestinationDriveChange(Sender: TObject);
    procedure ButtonCopyFilesClick(Sender: TObject);
    procedure SourceDirectoryChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure cbExt1Click(Sender: TObject);
    procedure cbExt2Click(Sender: TObject);
    procedure cbExt3Click(Sender: TObject);
    procedure ButtonHelpClick(Sender: TObject);
    procedure ButtonMkDirClick(Sender: TObject);
    procedure PopupItemShowHintsClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ButtonAbourClick(Sender: TObject);
    procedure DestinationDirectoryChange(Sender: TObject);
    procedure SourceFilesDblClick(Sender: TObject);
    procedure PopupItemDeleteSrcFileClick(Sender: TObject);
    procedure PopupItemRemovefromlistClick(Sender: TObject);
    procedure ButtonAutoCopyClick(Sender: TObject);
    procedure PopupItemLinktosourcedirectoryClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SetDefaultExtClick(Sender: TObject);
    procedure cbExt4Click(Sender: TObject);
    procedure MenuCustomizeClick(Sender: TObject);
    procedure MenuDeleteDestFileClick(Sender: TObject);
  private
    { Private-Deklarationen }
    IniFilename       : String;
    AccessDenied,
    AutoCopyFlag      : Boolean;
    SourceFilesLength,
    FreeBytes         : Longint;
    procedure FilterFileList;
    procedure ShowFreeBytes;
    procedure CheckForEqualPath;
    procedure WMAutoCopy(var Message: TMessage);  message WM_AUTOCOPY;
  public
    { Public-Deklarationen }
  end;

var
  MainForm: TMainForm;



implementation

{$R *.DFM}

uses DialMDir, About, IniFiles, {FMxUtil2,} BH_UTIL1, GLOBAL {, DEBUGGER}
     , CONFIRM, CUSTOMED ;


procedure TMainForm.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
  SourcePath, DestinationPath, S, HelpFilename : String;
  x,y,w,h:integer;

  procedure ScaleForm;  {with sideeffect to FormCreate}
    begin
    {This code came from Lloyd's help file!}
    scaled := true;
    if (screen.width <> ScreenWidth) then
      begin
      height := longint(height) * longint(screen.height) DIV ScreenHeight;
      width := longint(width) * longint(screen.width) DIV ScreenWidth;
      scaleBy(screen.width, ScreenWidth);
      end;
    end;

    procedure ReadIniFile;  {with sideeffect to FormCreate}
      var
        TempStr:string;
      begin
      s:=Application.ExeName;
      IniFilename:=AddBkSlash(ExtractFilePath(s)) +
                   ChangeFileExt(ExtractFileName(s), '.INI');
      {---section HINTS}
      IniFile := TIniFile.Create(IniFilename);
      ShowHint:=IniFile.ReadBool('HINT','show',True);
      PopupItemShowHints.Checked:=ShowHint;
      {---section POSITION}
      x:=IniFile.ReadInteger('POSITION','left',-1);
      y:=IniFile.ReadInteger('POSITION','top',-1);
      if (x<>-1) and (y<>-1) then
        begin
        Left:=x; Top:=y;
        Position:=poDesigned;
        end
      else
        Position:=poScreenCenter;
      {---section PATH}
      SourcePath:=ThePath(IniFile.ReadString ('PATH', 'source',      'c:\'));
      DestinationPath:=ThePath(IniFile.ReadString ('PATH', 'destination', 'c:\'));
      {Now SourcePath and DestinationPath are of the form
         x:\
         x:\aaa
         x:\aaa\bbb}
      with inifile do
        begin
        {---section APP}
        TempStr:=ReadString('APP', 'Name', AppName +
                                '  Copy delphi project files');
        if Pos(LowerCase('CopyDPR'), LowerCase(TempStr))=0 then
          TempStr:='CopyDPR' + TempStr;
        Caption:=TempStr;
        {---section SWITCHES}
        RadioGroupOverwrite.ItemIndex:=IniFile.ReadInteger('SWITCHES','overwrite', 1);
        cbExt1.Checked:=IniFile.ReadBool('SWITCHES','Exclude1', True); {binaries}
        cbExt2.Checked:=IniFile.ReadBool('SWITCHES','Exclude2', True); {backups}
        cbExt3.Checked:=IniFile.ReadBool('SWITCHES','Exclude3', False);{pictures}
        cbExt4.Checked:=IniFile.ReadBool('SWITCHES','Exclude4', False);{userdef}
        {---section EXTENSIONS}
        cbExt1.Caption:=ReadString('EXTENSIONS', 'Caption1', DefaultCaption1);
        cbExt1.Hint   :=ReadString('EXTENSIONS', 'Ext1',     DefaultExt1);
        cbExt2.Caption:=ReadString('EXTENSIONS', 'Caption2', DefaultCaption2);
        cbExt2.Hint   :=ReadString('EXTENSIONS', 'Ext2',     DefaultExt2);
        cbExt3.Caption:=ReadString('EXTENSIONS', 'Caption3', DefaultCaption3);
        cbExt3.Hint   :=ReadString('EXTENSIONS', 'Ext3',     DefaultExt3);
        cbExt4.Caption:=ReadString('EXTENSIONS', 'Caption4', DefaultCaption4);
        cbExt4.Hint   :=ReadString('EXTENSIONS', 'Ext4',     DefaultExt4);
        end;
      IniFile.Free;
      end;

begin{--------TMainForm.FormCreate---------------------------------------}
{ScaleForm}
Caption:='COPYDPR V' + AppVersion + '    Copy delphi project files';

s:=Application.ExeName;
HelpFilename :=ExtractFilePath(s) + ChangeFileExt(ExtractFileName(s), '.HLP');
Application.HelpFile:=HelpFilename;

AutoCopyFlag:=False;
ReadIniFile;

{process command line. commandline parameters override ini file settings}
if ParamCount>=1 then
  begin
  S:=ParamStr(1);
  if not FileExists(AddBkSlash(S)+'nul') then
    MessageDlg('First commandline parameter'+#$0d+'is not a path',
                mtError, [mbOK], 0)
  else
    begin
    SourcePath:=ThePath(S);
    DestinationPath:=ThePath(S);

    if ParamCount>=2 then
      begin
      S:=ParamStr(2);
      if Length(s)>=2 then
        if (S='/A') or (S='/a') then
          AutoCopyFlag:=True
        else
          MessageDlg('Second commandline parameter must be'+#$0d+
                     'empty or /A', mtError, [mbOK], 0)
      end;
    end;
  end{if ParamCount>=1};

SourcePath:=LowerCase(SourcePath);
DestinationPath:=LowerCase(DestinationPath);

SourceDrive.Drive:=SourcePath[1];
SourceDirectory.Directory:=SourcePath;
DestinationDrive.Drive:=DestinationPath[1];
DestinationDirectory.Directory:=DestinationPath;

FilterFileList;
CheckForEqualPath;
if AutoCopyFlag then
  PostMessage(Handle , WM_AUTOCOPY, 0, 0);
end{TMainForm.FormCreate};


procedure tMainForm.WMAutoCopy(var Message: TMessage);
  begin
  ButtonAutoCopyClick(Self);
  end;


procedure tMainForm.ShowFreeBytes;
var
  DriveChar:Char;
  DriveNum:Byte;
  F:extended;
begin
DriveChar:=DestinationDrive.Drive;
if DriveChar in ['a'..'z'] then DriveNum:=Ord(DriveChar)-Ord('a')+1;
if DriveChar in ['A'..'Z'] then DriveNum:=Ord(DriveChar)-Ord('A')+1;
FreeBytes:=DiskFree(DriveNum);
if FreeBytes>=0 then
  begin
  F:=FreeBytes div 1024;
  Free.Caption:=Format('%7.0n KB free', [F]);
  end
else
  Free.Caption:='0';
end;


procedure tMainForm.CheckForEqualPath;
  begin
  if (LowerCase(SourceDrive.Drive)=LowerCase(DestinationDrive.Drive)) and
     (LowerCase(SourceDirectory.Directory)=
      LowerCase(DestinationDirectory.Directory)) then
      begin
      AccessDenied:=True;
      ButtonCopyFiles.Enabled:=False;
      end
    else
      begin
      AccessDenied:=False;
      ButtonCopyFiles.Enabled:=True;
      end;
  end;


procedure tMainForm.FilterFileList;
  var i:integer;
      FileExt:string;
      DeleteFlag:Boolean;
      Sum, Len:LongInt;
      f:extended;
  begin
  SourceFiles.Update;
  With SourceFiles.Items do
    for i:=Count-1 downto 0 do
      begin
      FileExt:=LowerCase(ExtractFileExt(Strings[i]));
      FileExt:=Copy(FileExt, 2, 3); {remove leading dot}
      DeleteFlag:=False;
      if cbExt1.State=cbChecked then
        if Pos(FileExt, LowerCase(cbExt1.Hint))>0 then DeleteFlag:=True;
      if cbExt2.State=cbChecked then
        if Pos(FileExt, LowerCase(cbExt2.Hint))>0 then DeleteFlag:=True;
      if cbExt3.State=cbChecked then
        if Pos(FileExt, LowerCase(cbExt3.Hint))>0 then DeleteFlag:=True;
      if cbExt4.State=cbChecked then
        if Pos(FileExt, LowerCase(cbExt4.Hint))>0 then DeleteFlag:=True;
      if DeleteFlag then Delete(i); {remove file from list}
      end{for i};
  FileCount.Caption:='Files   : '+IntToStr(SourceFiles.Items.Count);
  Sum:=0;
  with SourceFiles do
    for i:=0 to Items.Count-1 do
      begin
      Len:=GetFileSize(AddBkSlash(SourceDirectory.Directory)+Items[i]);
      if Len>0 then
        Sum:=Sum+Len;
      end;
  f:=Sum;
  FilesLength.Caption:=Format('Length: %9.0n Bytes', [f]);
  SourceFilesLength:=Sum;
  end;


procedure TMainForm.ButtonExitClick(Sender: TObject);
begin
Close;
end;


procedure TMainForm.SourceDriveChange(Sender: TObject);
  begin
  if not DiskInserted(SourceDrive.Drive) then
    SourceDrive.Drive:='c';
  SourceDirectory.Drive := SourceDrive.Drive;
  Application.ProcessMessages;
  CheckForEqualPath;
  end{TMainForm.SourceDriveChange};


procedure TMainForm.DestinationDriveChange(Sender: TObject);
  begin
  if not DiskInserted(DestinationDrive.Drive) then
    DestinationDrive.Drive:='c';
  SourceDirectory.Drive := SourceDrive.Drive;
  DestinationDirectory.Drive := DestinationDrive.Drive;
  SourceDirectory.Drive := SourceDrive.Drive;
  ShowFreeBytes;
  CheckForEqualPath;
  end;



procedure TMainForm.ButtonCopyFilesClick(Sender: TObject);
var
  i:integer;
  SourceFile, DestinationPath, S : string;
  Continueing : Boolean;
  Overwrite   : TOverwrite;
  OverwriteAllFlag,
  OverwriteOneFlag : Boolean;
  CopyBuffer  : pointer;
  HalfClusterLength:Longint;
  F:String;

  Function FileAgeDifferenceString(SourceFile, DestinationPath:String):String;
    var
      SrcAge, DestAge : Longint;
      Diff : string[20];
    begin
    SrcAge:=FileAge(SourceFile);
    DestAge:=FileAge(AddBkSlash(DestinationPath) + ExtractFileName(SourceFile));
    If DestAge>SrcAge then
      Diff:='***newer*** than'
    else If DestAge=SrcAge then
      Diff:='equal the'
    else
      Diff:='older than';
    Result:='Destination file '+ExtractFileName(SourceFile)+
            ' is ' + Diff + ' source'
    end{FileAgeDifferenceString};

begin{ButtonCopyFilesClick}
if AccessDenied then
  begin
  MessageDlg('Destination=source not allowed', mtInformation, [mbOK], 0);
  exit;
  end;

if SourceFiles.Items.Count<1 then
  begin
  MessageDlg('There are no files to copy', mtInformation, [mbOK], 0);
  exit;
  end;

{enough space on destination drive ?}
if DestinationDrive.Drive in ['A','a','B','b'] then
  HalfClusterLength:=1024
else
  HalfClusterLength:=8192;
if (SourceFilesLength+SourceFiles.Items.Count*HalfClusterLength) > FreeBytes then
  begin
  if MessageDlg('There is possibly not enough free space to copy'+#$0d+
                'Proceed ?', mtConfirmation, [mbYes, mbNo], 0)
  in [mrNo, mrCancel] then
    exit;
  end;

case RadioGroupOverwrite.ItemIndex of
  0:   Overwrite:=Yes;
  1:   Overwrite:=Ask;
  else Overwrite:=No;
  end;
OverwriteAllFlag:=(Overwrite=Yes);
OverwriteOneFlag:=False;

GetMem(CopyBuffer, CopyBufferLength);    { allocate the buffer }
try {copy selected files from source to destination}
  MainForm.Enabled:=False;
  {LockWindowUpdate(DestinationFiles.Handle);}
  MainForm.Cursor:=crHourGlass;
  GaugeCounter.Visible:=True;
  Application.ProcessMessages;
  DestinationPath:=StripBkSlash(DestinationDirectory.Directory);
  Continueing:=True;
  i:=0;
  with SourceFiles do
    repeat {-----for all files------------------------------------------------}
      GaugeCounter.Caption:=IntToStr(Items.Count-i);
      Application.ProcessMessages;
      ItemIndex:=i;
      SourceFile:=AddBkSlash(SourceDirectory.Directory) + Items[i];
      try
        CopyFileOB(SourceFile, DestinationPath, OverwriteAllFlag or OverwriteOneFlag,
                   CopyBuffer, CopyBufferLength);
        OverwriteOneFlag:=False;
      except
        on E:EDiskFullError do
          begin
          MessageDlg(E.Message+#$0d+'Copying aborted.', mtError, [mbOK], 0);
          Continueing:=false;
          end;
        on E:EFopenError do
          if MessageDlg(
            'Problem with source file ' + ExtractFilename(SourceFile) +
            #$0d + E.Message + #$0d + ' Continue with following files ?',
            mtError, [mbYes, mbNo], 0)
          in [mrNo, mrCancel]
          then Continueing:=false;
        on E:EFcreateError do
          if MessageDlg(
            'Problem with destination file ' + ExtractFilename(SourceFile) +
            #$0d + E.Message + #$0d + ' Continue with following files ?',
            mtError, [mbYes, mbNo], 0)
          in [mrNo, mrCancel]
          then Continueing:=false;
        on E:ECopyError do
          if MessageDlg(
            'Problem while copying:' + #$0d + E.Message + #$0d +
            ' Continue with following files ?',
            mtError, [mbYes, mbNo], 0)
          in [mrNo, mrCancel]
          then Continueing:=false;
        on E:EOverwriteError do
          case Overwrite of
            No : begin
                 MessageDlg(E.Message + #$0d +
                            'File '+SourceFile+' not copied.' + #$0d +
                            FileAgeDifferenceString(SourceFile,DestinationPath),
                            mtInformation, [mbOk], 0);
                 end;

            Ask: begin
                 case Confirm.ExecuteP('Confirm',
                            FileAgeDifferenceString(SourceFile,DestinationPath),
                            'Overwrite ?')
                 of
                   mrYes:    begin
                             dec(i); {try this file again...}
                             OverwriteOneFlag:=True;
                             end;
                   mrNo:     {Ok, we did'nt it};
                   mrCancel,
                   mrAbort:  Continueing:=false;
                   mrAll:    begin
                             dec(i); {try this file again and all following...}
                             OverwriteAllFlag:=true;
                             end;
                 end{case};
                 end;

            Yes: {this case should never happen}
          end{case Overwrite};

      end{try except};
      DestinationFiles.Update;
      Application.ProcessMessages;
      inc(i);
    until (i>=Items.Count) or not Continueing; {-----for all files------------}

finally
  FreeMem(CopyBuffer, CopyBufferLength); { free the buffer }
  {LockWindowUpdate(0);}
  SourceDirectory.Update;
  GaugeCounter.Caption:='';
  GaugeCounter.Visible:=False;
  ShowFreeBytes;
  MainForm.Cursor:=crDefault;
  DestinationFiles.Enabled:=True;
  MainForm.Enabled:=True;
end{try copy selected files from source to destination};
end;



procedure TMainForm.SourceDirectoryChange(Sender: TObject);
begin
FilterFileList;
CheckForEqualPath;
end;


procedure TMainForm.cbExt1Click(Sender: TObject);
begin
FilterFileList;
end;


procedure TMainForm.cbExt2Click(Sender: TObject);
begin
FilterFileList;
end;


procedure TMainForm.cbExt3Click(Sender: TObject);
begin
FilterFileList;
end;

procedure TMainForm.cbExt4Click(Sender: TObject);
begin
FilterFileList;
end;


procedure TMainForm.ButtonHelpClick(Sender: TObject);
  begin
  Application.HelpCommand(HELP_CONTENTS, 0);
  end;


procedure TMainForm.ButtonMkDirClick(Sender: TObject);
begin
with FormMkDir do
  begin
  with CurrentPath do Caption:=AddBkSlash(DestinationDirectory.Directory);
  NewDir.Text:='';
  if (ShowModal=idOK) and (NewDir.Text<>'') then
    begin
    Application.ProcessMessages;
    MkDir(CurrentPath.Caption + NewDir.Text);
    Application.ProcessMessages;
    DestinationDirectory.Directory:=CurrentPath.Caption + NewDir.Text;
    Application.ProcessMessages;
    if CopyFilesButtonPushed then
      ButtonCopyFilesClick(Sender);
    end;
  end{with FormMkDir};
end;


procedure TMainForm.PopupItemShowHintsClick(Sender: TObject);
begin
PopupItemShowHints.Checked:=not PopupItemShowHints.Checked;
ShowHint:=PopupItemShowHints.Checked;
end;


procedure TMainForm.FormDestroy(Sender: TObject);
var
  IniFile: TIniFile;
  S: String;
begin
IniFile := TIniFile.Create(IniFilename);
IniFile.WriteBool('HINT','show',ShowHint);

IniFile.WriteInteger('POSITION','left',  Left);
IniFile.WriteInteger('POSITION','top',   Top);

S:=SourceDirectory.Directory;
if S[1] in ['A','a','B','b'] then S:='c:\';
IniFile.WriteString ('PATH', 'source', S);
S:=DestinationDirectory.Directory;
if S[1] in ['A','a','B','b'] then S:='c:\';
IniFile.WriteString ('PATH', 'destination', S);

with inifile do
  begin
  IniFile.WriteString('APP', 'Name', Caption);
  IniFile.WriteInteger('SWITCHES','overwrite', RadioGroupOverwrite.ItemIndex);
  IniFile.WriteBool   ('SWITCHES','Exclude1', cbExt1.Checked); {binaries}
  IniFile.WriteBool   ('SWITCHES','Exclude2', cbExt2.Checked); {backups}
  IniFile.WriteBool   ('SWITCHES','Exclude3', cbExt3.Checked); {pictures}
  IniFile.WriteBool   ('SWITCHES','Exclude4', cbExt4.Checked); {userdef}
  WriteString('EXTENSIONS', 'Caption1', cbExt1.Caption);
  WriteString('EXTENSIONS', 'Ext1',     cbExt1.Hint);
  WriteString('EXTENSIONS', 'Caption2', cbExt2.Caption);
  WriteString('EXTENSIONS', 'Ext2',     cbExt2.Hint);
  WriteString('EXTENSIONS', 'Caption3', cbExt3.Caption);
  WriteString('EXTENSIONS', 'Ext3',     cbExt3.Hint);
  WriteString('EXTENSIONS', 'Caption4', cbExt4.Caption);
  WriteString('EXTENSIONS', 'Ext4',     cbExt4.Hint);
  end;
IniFile.Free;
end;


procedure TMainForm.ButtonAbourClick(Sender: TObject);
begin
AboutBox.ShowModal;
end;


procedure TMainForm.DestinationDirectoryChange(Sender: TObject);
begin
CheckForEqualPath;
end;


procedure TMainForm.SourceFilesDblClick(Sender: TObject);
var    sum, Len : LongInt;
       i, Index : Integer;
       f        : extended;
begin
  {Remove source file from the list}
  with SourceFiles do
    begin
    Index:=Itemindex;
    Items.Delete(ItemIndex);
    if Index>=Items.Count then dec(Index);
    ItemIndex:=Index;
    end;
  FileCount.Caption:='Files   : '+IntToStr(SourceFiles.Items.Count);
  Sum:=0;
  with SourceFiles do
    for i:=0 to Items.Count-1 do
      begin
      Len:=GetFileSize(AddBkSlash(SourceDirectory.Directory)+Items[i]);
      if Len>0 then
        Sum:=Sum+Len;
      end;
  f:=Sum;
  FilesLength.Caption:=Format('Length: %9.0n Bytes', [f]);
end;


procedure TMainForm.PopupItemDeleteSrcFileClick(Sender: TObject);
  var
    Filename : string;
    Index    : Integer;
  begin
  Index:=SourceFiles.ItemIndex;
  if Index<0 then
    begin
    MessageDlg('Please mark a source file'#13'with the left mouse',
                mtInformation, [mbOK], 0);
    exit;
    end;
  Filename:=AddBkSlash(SourceDirectory.Directory) +
            SourceFiles.Items[Index];
  if MessageDlg('Delete file ' + Filename,
     mtConfirmation, [mbYes, mbNo], 0) = mrYes then
     if not DeleteFileAndAsk(Filename, RadioGroupOverwrite.ItemIndex=0) then
       MessageDlg('Could not delete file', mtError, [mbOK], 0)
     else
       with SourceFiles do
         begin
         Application.ProcessMessages;
         Items.Delete(Index);
         if Index>=Items.Count then dec(Index);
         ItemIndex:=Index;
         end;
  end;


procedure TMainForm.PopupItemRemovefromlistClick(Sender: TObject);
begin
if SourceFiles.ItemIndex<0 then
  begin
  MessageDlg('Please mark a source file'#13'with the left mouse',
              mtInformation, [mbOK], 0);
  exit;
  end;
SourceFilesDblClick(Sender);
end;


procedure TMainForm.ButtonAutoCopyClick(Sender: TObject);
  var
    HalfClusterLength:Longint;
    OldDir,
    NewDir    :string;
    NumberStr :string[8];
  begin
  if SourceFiles.Items.Count<1 then
    begin
    MessageDlg('There are no files to copy', mtInformation, [mbOK], 0);
    exit;
    end;

  {enough space on destination drive ?}
  if DestinationDrive.Drive in ['A','a','B','b'] then
    HalfClusterLength:=1024
  else
    HalfClusterLength:=8192;
  if (SourceFilesLength+SourceFiles.Items.Count*HalfClusterLength) > FreeBytes then
    begin
    if MessageDlg('There is possibly not enough free space to copy'+#$0d+
                  'Proceed ?', mtConfirmation, [mbYes, mbNo], 0)
    in [mrNo, mrCancel] then
      exit;
    end;

  OldDir:=DestinationDirectory.Directory;
  NumberStr:=GetHighestDirNumberString(OldDir);

  if NumberStr='' then
    exit;

  NewDir:=AddBkSlash(OldDir) + NumberStr;

  if mrYes<>MessageDlg('Create new dir' +#$0d + NewDir + #$0d +
                       ' and copy files',  mtConfirmation, [mbYes, mbNo], 0)
  then
    exit;

  try
    MkDir(NewDir);
  except on E:EInOutError do
      begin
      MessageDlg('Could not create directory:' + #$0d + 'Details:' + #$0d +
                  E.Message, mtError, [mbOK], 0);
      exit;
      end;
  end;

  DestinationDirectory.Directory:=NewDir;
  Application.ProcessMessages;
  ButtonCopyFilesClick(Sender);
  DestinationDirectory.Directory:=OldDir;
  end;


procedure TMainForm.PopupItemLinktosourcedirectoryClick(Sender: TObject);
begin
DestinationDrive.Drive:=SourceDrive.Drive;
DestinationDirectory.Directory:=SourceDirectory.Directory;
end;

procedure TMainForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if(Key=VK_F1) then
  Application.HelpCommand(HELP_CONTENTS, 0);
{if(Key=VK_F2) then
  Confirm.ExecuteP('aaaaaaaaaa','bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb','ccccccc');}
end;

procedure TMainForm.SetDefaultExtClick(Sender: TObject);
begin
if mrYes=MessageDlg('All settings will be changed to'#13'default values. Proceed ?',
        mtConfirmation, [mbYes, mbNo], 0)
then
  begin
  self.Caption:=AppName+'  Copy delphi project files';
  cbExt1.Caption:=DefaultCaption1; cbExt1.Hint:=DefaultExt1; cbExt1.Checked:=True;
  cbExt2.Caption:=DefaultCaption2; cbExt2.Hint:=DefaultExt2; cbExt2.Checked:=True;
  cbExt3.Caption:=DefaultCaption3; cbExt3.Hint:=DefaultExt3; cbExt3.Checked:=False;
  cbExt4.Caption:=DefaultCaption4; cbExt4.Hint:=DefaultExt4; cbExt4.Checked:=False;
  RadioGroupOverwrite.ItemIndex:=1;
  end;
end;


procedure TMainForm.MenuCustomizeClick(Sender: TObject);
begin
with FormCustomize do
  begin
  EditProgTitle.Text:=self.Caption;
  EditCaption1.Text  :=cbExt1.Caption;
  EditExtension1.Text:=cbExt1.Hint;
  EditCaption2.Text  :=cbExt2.Caption;
  EditExtension2.Text:=cbExt2.Hint;
  EditCaption3.Text  :=cbExt3.Caption;
  EditExtension3.Text:=cbExt3.Hint;
  EditCaption4.Text  :=cbExt4.Caption;
  EditExtension4.Text:=cbExt4.Hint;
  if mrOK = FormCustomize.ShowModal then
    begin
    self.Caption:=EditProgTitle.Text;
    cbExt1.Caption:=EditCaption1.Text;
    cbExt1.Hint   :=EditExtension1.Text;
    cbExt2.Caption:=EditCaption2.Text;
    cbExt2.Hint   :=EditExtension2.Text;
    cbExt3.Caption:=EditCaption3.Text;
    cbExt3.Hint   :=EditExtension3.Text;
    cbExt4.Caption:=EditCaption4.Text;
    cbExt4.Hint   :=EditExtension4.Text;
    FilterFileList;
    end;
  end;
end;

procedure TMainForm.MenuDeleteDestFileClick(Sender: TObject);
  var
    Filename : string;
    Index    : Integer;
  begin
  Index:=DestinationFiles.ItemIndex;
  if Index<0 then
    begin
    MessageDlg('Please mark a Destination file'#13'with the left mouse',
                mtInformation, [mbOK], 0);
    exit;
    end;
  Filename:=AddBkSlash(DestinationDirectory.Directory) +
            DestinationFiles.Items[Index];
  if MessageDlg('Delete file ' + Filename,
     mtConfirmation, [mbYes, mbNo], 0) = mrYes then
     if not DeleteFileAndAsk(Filename, RadioGroupOverwrite.ItemIndex=0) then
       MessageDlg('Could not delete file', mtError, [mbOK], 0)
     else
       with DestinationFiles do
         begin
         Application.ProcessMessages;
         Items.Delete(Index);
         if Index>=Items.Count then dec(Index);
         ItemIndex:=Index;
         end;
  end;

end.

